use x86_64::structures::gdt::{Descriptor, GlobalDescriptorTable};

use lazy_static::lazy_static;

use super::asm::*;

lazy_static! {
    pub static ref GDT: GlobalDescriptorTable = {
        let mut gdt = GlobalDescriptorTable::new();
        gdt.append(Descriptor::kernel_code_segment());
        gdt
    };
}

pub fn setup_gdt() {
    unsafe {
        interrupt_disable();
    }
    GDT.load();
    unsafe {
        interrupt_enable();
    }
}
